/* cssbj32.c */
/*
   Solve the system of eqautions
   y = a*x*x  and x = (y + b)*(y + b) + c
*/
#include "../csc/csc.h"
#include "../eagle/eagle.h"
#include "Newton.h"
#define  NN 100

main()
{
    Window w0, w1, w2, w; KeySym key;
    int wx, wy, BP, KP, button, etype, xint, yint, s, t;
    unsigned long blue, red;
    unsigned long SpringGreen, SkyBlue1, yellow, chocolate3, ivory2;
    double xx1[NN], yy1[NN], xx2[NN], yy2[NN]; double dm;
    double x[2]; double r, conv, xmin, xmax, ymin, ymax, x0, y0;
    int i, Ilimit;
    double xh, yh;

    a = 3.0; b = -2.0; c = -1.0; conv = 1.0e-9; Ilimit = 30;

    xmin = -2.5; xmax = 2.5; ymin = -1.0; ymax = 4.0;
    wx = 620; wy = 600;
    w0 = x_init(wx, wy+100, "Eagle_data");
    w1 = w_open(w0,  20, wy+10, 270, 80);
    w2 = w_open(w0, 320, wy+10, 270, 80);
    blue = set_color(0, 0, 255); red  = set_color(255, 0, 0);
    SpringGreen = set_color(  0, 255, 127);
    SkyBlue1    = set_color(135, 206, 255);
    yellow      = set_color(255, 255,   0);
    chocolate3  = set_color(205, 102,  29);
    ivory2      = set_color(238, 238, 224);
    m_trans_def(xmin, ymin, xmax, ymax, 20, 20, wx-40, wy-20);
    dm = 4.0/Ax_eagle;
    m_line(xmin, 0.0, xmax, 0.0); m_line(0.0, ymin, 0.0, ymax);
    for (i = 0; i < NN; i++) {
       xx1[i] = xmin + (xmax-xmin)*i/(NN-1);
       yy2[i] = ymin + (ymax-ymin)*i/(NN-1);
       yy1[i] = a*xx1[i]*xx1[i];
       xx2[i] = (yy2[i] + b)*(yy2[i] + b) + c;
    }
    m_lines(NN, xx1, yy1); m_lines(NN, xx2, yy2);

    KP = 1; BP = 1;
    xh = (xmax-xmin)/100.0;
    yh = (ymax-ymin)/100.0;
    for (s = 0; s <= 100; s++) {
       for (t = 0; t <= 100; t++) {
          x[0] = xmin + xh*s;
          x[1] = ymin + yh*t;
          x0 = x[0]; y0 = x[1];
          r = 1.0; i = 0;
	  while (r > conv) {
             r = Newton(2, x); 
	     i = i + 1; if (i > Ilimit) break;
	  }
	set_foreground(red);
	m_circle(x[0], x[1], dm, dm , 1);
        w_select(w2); w_clear(); 
	  w_select(w0);
	  if ((i > Ilimit) && (r > conv)) set_foreground(ivory2);
	  if ((r<conv)&&(x[0]>0.0)&&(x[1]>-b)) set_foreground(SpringGreen);
	  if ((r<conv)&&(x[0]>0.0)&&(x[1]<-b)) set_foreground(SkyBlue1);
	  if ((r<conv)&&(x[0]<0.0)&&(x[1]>-b)) set_foreground(yellow);
	  if ((r<conv)&&(x[0]<0.0)&&(x[1]<-b)) set_foreground(chocolate3);
	  x[0] = x0; x[1] = y0; r = 1.0; i =0; m_circle(x[0], x[1], dm, dm, 1);
       }
    }
    w_close(w1); w_close(w2); w_close(w0); x_term();
}

