/* cssbj51.c */
#include <stdio.h>
#include <math.h>
#include "../csc/csc.h"
#include "../eagle/eagle.h"
#include "Runge_Kutta.h"
#define Mmax (2000)

void solve(x0, y0, button, dt, M, xx, yy, xmin, xmax, ymin, ymax)
    double x0, y0, dt, xmin, xmax, ymin, ymax; int button, M;
    double xx[], yy[];
{
    double x[2]; int i, j;

    if (button == 1) { dt = -dt; button = 3;}

    xx[0] = x0; yy[0] = y0; x[0] = x0; x[1] = y0;
    for (j=1; j<=M; j++) {
        Runge_Kutta(2, 0.0, x, dt); xx[j] = x[0]; yy[j] = x[1];
	if ((x[0]<xmin)||(x[0]>xmax)||(x[1]<ymin)||(x[1]>ymax)) {
	     for (i=j; i<=M; i++) { xx[i] = xx[j-1]; yy[i] = yy[j-1]; }
	     j = M+1;
        }
    }
}

void solve_draw(x, y, button, dt, Mold, M,
	        old_x, old_y, new_x, new_y, xmin, xmax, ymin, ymax)
    double x, y, dt, xmin, xmax, ymin, ymax; int button, Mold, M;
    double old_x[], old_y[], new_x[], new_y[];
{
    int j;
    extern void solve();
    solve(x, y, button, dt, M, new_x, new_y, xmin, xmax, ymin, ymax);
    m_lines(Mold, old_x, old_y); m_lines(M, new_x, new_y);
    for (j=0; j<=M; j++)
       { old_x[j] = new_x[j]; old_y[j] = new_y[j]; }
}

void change_dt(dt, dt_change, w0, w1, key)
     double *dt, dt_change; Window w0, w1; KeySym key;
{
     if (key == XK_i) *dt = (*dt)*dt_change;
     if (key == XK_d) *dt = (*dt)/dt_change;
     w_select(w1); w_clear(); x_printf(0, 30, "dt = %lf", *dt);
     w_select(w0);
}

void  change_M(M, M_change, w0, w1, key)
     int *M; double M_change; Window w0, w1; KeySym key;
{
     if (key == XK_l) *M = (*M)*M_change;
     if (key == XK_s) *M = (*M)/M_change;
     if (*M > Mmax - 1) *M = Mmax - 1; if (*M < 10) *M = 10;
     w_select(w1); w_clear(); x_printf(0, 30, " M = %d", *M);
     w_select(w0);
}

void koyuu_v(a11, a12, a21, a22, p, q)
double a11, a12, a21, a22, *p, *q;
{

   if (fabs(a11)>=fabs(a12) && fabs(a11)>=fabs(a21) && fabs(a11)>=fabs(a22)) {
      *p = -a12/a11;
      *q = 1.0;
   }
   else if (fabs(a12) >= fabs(a11) && fabs(a12) >= fabs(a21) &&                             fabs(a12)>=fabs(a22)) {
      *p = 1.0;
      *q = -a11/a12;
   }
   else if (fabs(a21) >= fabs(a11) && fabs(a21) >= fabs(a21) &&
            fabs(a21)>=fabs(a22)) {
      *p = -a22/a21;
      *q = 1.0;
   }
   else if (fabs(a22) >= fabs(a11) && fabs(a22) >= fabs(a12) &&
            fabs(a22)>=fabs(a21)) {
      *p = 1.0;
      *q = -a21/a22;
   }
}
      
main()
{
    Window      w0, w1, w2, w, w3;
    KeySym      key;
    double      new_x[Mmax], new_y[Mmax], old_x[Mmax], old_y[Mmax];
    double      x, y, xmin, xmax, ymin, ymax, dt;
    double      dt_change, M_change;
    int         wx, wy, M, Mold, j;
    int         BP, BR, KP, MN, button, etype, xint, yint;
    double      ramuda1, ramuda2, hanbetu, m, n, p, q;
    extern void solve_draw(), solve(), koyuu_v();

    xmax = 5.0; xmin = -xmax; ymax = xmax; ymin = -ymax;
    dt = 0.1; M = 100; dt_change = 1.1; M_change = 1.1;


    printf("a11 = ");
    scanf("%lf",&a);

    printf("a12 = ");
    scanf("%lf", &b);

    printf("a21 = ");
    scanf("%lf", &c);

    printf("a22 = ");
    scanf("%lf", &d);

   m = -(a+d);
   n = a*d - b*c;

   hanbetu = m*m - 4.0*n;

   if (hanbetu > 0.0) {
      if (m > 0.0) {
         ramuda1 = (-m - sqrt(m*m - 4.0*n))/2.0;
         ramuda2 = 2.0*n/(-m - sqrt(m*m - 4.0*n));
      }
      else {
         ramuda1 = (-m + sqrt(m*m - 4.0*n))/2.0;
         ramuda2 = 2.0*n/(-m + sqrt(m*m - 4.0*n));
      }
   }
   else if (hanbetu == 0.0) {
      ramuda1 = -m/2.0;
      ramuda2 = ramuda1;
   }
   else {
      ramuda1 = -m/2.0;
      ramuda2 = sqrt(4.0*n - m*m)/2.0;
   } 

    wx = 620; wy = 600;
    w0 = x_init(wx, wy+180, "Eagle_data");
    w1 = w_open(w0,  20, wy+10, 270, 35);
    w2 = w_open(w0, 320, wy+10, 270, 35);
    w3 = w_open(w0,  20, wy+60, 550, 35);
    m_trans_def(xmin, ymin, xmax, ymax, 20, 20, wx-40, wy-20);
    p_control_eagle = 1; m_box(xmin, ymin, xmax, ymax, 0);
    m_line(xmin, 0.0, xmax, 0.0); m_line(0.0, ymin, 0.0, ymax);
    x_printf(20, 18, "REPORT5-1");

    w_select(w1); w_clear(); x_printf(0, 30, "dt = %lf", dt);
    w_select(w2); w_clear(); x_printf(0, 30, " M = %d", M);
    w_select(w3); w_clear(); 

    if (hanbetu >= 0.0) {
       x_printf(0, 30, "koyuuti = %lf, %lf", ramuda1, ramuda2);
    }
    else {
       x_printf(0, 30, "koyuuti = %lf+(%lf)i, %lf-(%lf)i", ramuda1, ramuda2,
                                                          ramuda1, ramuda2);
    }
    w_select(w0); KP = 1; BP = 1; BR = 1; MN = 1;

    if (hanbetu >= 0.0) {
       koyuu_v(a-ramuda1, b, c, d-ramuda1, &p, &q);
       m_line(-(p*5), -(q*5), p*5, q*5);

       koyuu_v(a-ramuda2, b, c, d-ramuda2, &p, &q);
       m_line(-(p*5), -(q*5), p*5, q*5);
    }

    while (1) {

      etype = e_wait(KP, BP, 0, 0, 0, 0, &xint, &yint, &button, &w, &key);
      m_trans_x_to_m(xint, yint, &x, &y);
      set_draw_mode(1); p_control_eagle = 0;

      if ((etype==KeyPress)&&(key == XK_Escape)) break;

      if ((etype==KeyPress)&&((key == XK_i)||(key == XK_d)))
	  change_dt(&dt, dt_change, w0, w1, key);

      if ((etype==KeyPress)&&((key == XK_l)||(key == XK_s)))
	  change_M(&M, M_change, w0, w2, key);

      if ((etype == ButtonPress)&&(button != 2)) {
	solve(x, y, button, dt, M, new_x, new_y, xmin, xmax, ymin, ymax);
	m_lines(M, new_x, new_y);
	for (j=0; j<=M; j++)
	  { old_x[j] = new_x[j]; old_y[j] = new_y[j]; }
	
	while (1) {
	 
          etype = e_wait(KP, 0, BR, MN, 0, 0, &xint, &yint, &button, &w, &key);
          m_trans_x_to_m(xint, yint, &x, &y);

	  if (etype==ButtonRelease) { m_lines(M, old_x, old_y); break; }

          if ((etype==KeyPress)&&((key == XK_i)||(key == XK_d))) {
	      change_dt(&dt, dt_change, w0, w1, key);
	      solve_draw(x, y, button, dt, M, M,
			 old_x, old_y, new_x, new_y, xmin, xmax, ymin, ymax);
          }

          if ((etype==KeyPress)&&((key == XK_l)||(key == XK_s))) {
	      Mold = M; change_M(&M, M_change, w0, w2, key);
	      solve_draw(x, y, button, dt, Mold, M,
			 old_x, old_y, new_x, new_y, xmin, xmax, ymin, ymax);
	  }

          if ((etype==KeyPress)&&(key == XK_f)) {
	      m_lines(M, old_x, old_y); set_draw_mode(0); p_control_eagle = 1;
	      m_lines(M, new_x, new_y); break;
	  }
         
	  if (etype == MotionNotify)
	      solve_draw(x, y, button, dt, M, M,
	         	 old_x, old_y, new_x, new_y, xmin, xmax, ymin, ymax);
        }
      }
    }

    w_close(w1); w_close(w2); w_close(w3); w_close(w0); x_term();
}

