/* cssbj72.c */
/*
   Shootimg method
*/
#include "../csc/csc.h"
#include "../eagle/eagle.h"
#include "Runge_Kutta.h"
#define Mmax (201)

main()
{
    Window      w0;
    KeySym      key;
    double      uu[2], u[Mmax], v[Mmax];
    double      L, x, dx, xmin, xmax, umin, umax;
    double      v0_P, v0_N, uL_P, uL_N;
    int         wx, wy, M, satisfied, j, M_P, M_N;
    unsigned long black, blue;
    FILE *fp;
    double fa, fb, fc, u0_P, u0_N;

    L = 1.0; xmax = L; xmin = 0.0;
    satisfied = 0;

    M_P = 0; M_N = 0;
    v0_P = 0.0; v0_N = 0.0;
    uL_P = 1.0e50; uL_N = -uL_P;
    u0_P = 1.0e50; u0_N = -u0_P;

    wx = 840; wy = 400;
    w0 = x_init(wx, wy+50, "Eagle_data71_1");
    black = set_color(0, 0, 0);
    blue = set_color(0, 0, 255);

   printf("c = ");
   scanf("%lf", &c);

    while (satisfied != 1) {
       printf("Input number of freedom. M < %d  M = ", Mmax);
       scanf("%d", &M);
       dx = L/M;
       printf("u(0) = "); scanf("%lf", &uu[0]);
       uu[1] = 0.0;
       u[0] = uu[0]; v[0] = uu[1];
       for (j = 0; j < M; j++) {
	 x = j*dx;
         Runge_Kutta(2, x, uu, dx);
	 u[j+1] = uu[0]; v[j+1] = uu[1];
       }
       umax = 1.0e-50; umin = -1.0e-50;
       for (j = 0; j <= M; j++) {
	 if(umax < u[j]) umax = u[j];
	 if(umin > u[j]) umin = u[j];
       }
       umax = 1.1*umax; umin = 1.1*umin;
       if ((u[M] >= 0.0) && (u[M] < uL_P))
         { uL_P = u[M]; M_P = M; v0_P = v[0];}
       if ((u[M] <= 0.0) && (u[M] > uL_N))
         { uL_N = u[M]; M_N = M; v0_N = v[0];}

       if ((u[M] >= 0.0) && (u[M] < u0_P)) {
          u0_P = u[0];
       }
       else if((u[M] <= 0.0) && (u[M] > u0_N)) {
          u0_N = u[0];
       }


      if (u0_P != 1.0e50 && u0_N != -1.0e50) {
          while (fabs(u[M]) >= 1.e-4) {
              fa = u0_P;
              fb = u0_N;

             fc = (fa + fb)/2.0;

             uu[0] = fc;
             uu[1] = 0.0;
             u[0] = fc; v[0] = 0.0;
 
             for (j = 0; j < M; j++) {
                x = j*dx;
                Runge_Kutta(2, x, uu, dx);
                u[j+1] = uu[0]; v[j+1] = uu[1];
             }
             umax = 1.0e-50; umin = -1.0e-50;
             for (j = 0; j <= M; j++) {
                if(umax < u[j]) umax = u[j];
                if(umin > u[j]) umin = u[j];
             }
             umax = 1.1*umax; umin = 1.1*umin;
             if ((u[M] >= 0.0) && (u[M] < uL_P))
                { uL_P = u[M]; M_P = M; v0_P = v[0];}
             if ((u[M] <= 0.0) && (u[M] > uL_N))
                { uL_N = u[M]; M_N = M; v0_N = v[0];}

             if (u[M] >= 0.0 && u[M] < u0_P) {
                u0_P = u[0];
             }
             else if ((u[M] < 0.0) && (u[0] > u0_N)) {
                u0_N = u[0];
             } 
          }
      } 
             
       w_clear();
       m_trans_def(xmin, umin, xmax, umax, 20, 60, wx-40, wy-60);
       set_foreground(black);
       m_box(xmin, umin, xmax, umax, 0); m_line(xmin, 0.0, xmax, 0.0);
       x_printf(20, 20, "u(0) = %lf, umin = %lg, umax = %lg",
			 u[0], umin, umax);
       x_printf(20, 40, "M = %d, v(0) = %lf, u(L) = %lg",
			 M, v[0],  u[M]);
       x_printf(20, wy+20,
		"Nearest Positive:  M = %d, u(0) = %lg, u(L) = %lg",
		M_P, u0_P, uL_P);
       x_printf(20, wy+40,
		"Nearest Negative:  M = %d, u(0) = %lg, u(L) = %lg",
		M_N, u0_N, uL_N);
       set_foreground(blue); m_graph(M, xmin, xmax, u);

       printf("Are you satisfied ? (yes:1 no:0) ");
       scanf("%d", &satisfied);
    }

    w_clear(); p_control_eagle = 1;
    m_box(xmin, umin, xmax, umax, 0); m_line(xmin, 0.0, xmax, 0.0);
    x_printf(20, 20, "u(0) = %lf, umin = %lg, umax = %lg",
		      u[0], umin, umax);
    x_printf(20, 40, "M = %d, v(0) = %lf, u(L) = %lg",
		      M, v[0],  u[M]);
    m_graph(M, xmin, xmax, u);

    fp = fopen("result.data", "w");
    fprintf(fp, "M = %d\n", M);
    for (j = 0; j <= M; j++) fprintf(fp, "%lf %lf\n", u[j], v[j]);
    fclose(fp);

    w_close(w0); x_term();
}

