/* cssbj82.c */
/*
   Finite Difference Method
*/
#include "../csc/csc.h"
#include "../eagle/eagle.h"
#include "Runge_Kutta.h"
#define Mmax (401)

void set_matrix(M, dx, AA, BB, CC)
    int M; double dx; double AA[], BB[], CC[];
{
    int j; double tmp;
    tmp = 1.0/dx/dx;
    AA[0] = tmp + 1.0/2.0; BB[0] = -tmp; CC[0] = 0.0; 
    for (j = 1; j < M; j++) {
       AA[j] = 2.0*tmp + 1.0;
       BB[j] = -tmp + c/(2.0*dx); CC[j] = -tmp - c/(2.0*dx);
    }
    AA[M] = 1.0; BB[M] = 0.0; CC[M] = 0.0;
}

main()
{
    Window      w0;
    KeySym      key;
    double      u[Mmax], AA[Mmax], BB[Mmax], CC[Mmax];
    double      L, x, dx, xmin, xmax, umin, umax;
    int         wx, wy, M, j;
    unsigned long black, blue;
    FILE *fp;
    extern void set_matrix();
    extern double c;

    L = 1.0; xmax = L; xmin = 0.0;

    wx = 840; wy = 400;
    w0 = x_init(wx, wy+50, "Eagle_data");
    black = set_color(0, 0, 0);
    blue = set_color(0, 0, 255);

    printf("c = ");
    scanf("%lf", &c);

    printf("Input number of freedom. M < %d  M = ", Mmax);
    scanf("%d", &M);
    
    dx = L/M;
    set_matrix(M, dx, AA, BB, CC);
    LUdecomp(M+1, AA, BB, CC);
    for (j = 0; j <= M; j++)
    {  x = j*dx; u[j] = 1.0; }
    u[0] = u[0]/2.0; u[M] = 0.0; 
    LUsolve(M+1, AA, BB, CC, u);
    umax = 1.0e-50; umin = -1.0e-50;
    for (j = 0; j <= M; j++) {
	 if(umax < u[j]) umax = u[j];
	 if(umin > u[j]) umin = u[j];
    }
    umax = 1.1*umax; umin = 1.1*umin;
    w_clear(); p_control_eagle = 1;
    m_trans_def(xmin, umin, xmax, umax, 20, 60, wx-40, wy-60);
    set_foreground(black);
    m_box(xmin, umin, xmax, umax, 0); m_line(xmin, 0.0, xmax, 0.0);
    x_printf(20, 20, "umin = %lg, umax = %lg M = %d",
			 umin, umax, M);
    set_foreground(blue); m_graph(M, xmin, xmax, u);

    fp = fopen("result.data", "w");
    fprintf(fp, "M = %d\n", M);
    for (j = 0; j <= M; j++) fprintf(fp, "%lf\n", u[j]);
    fclose(fp);

    printf("Type 0 to exit "); scanf("%d", &j);
    w_close(w0); x_term();
}

