#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../csc/csc.h"
#include "../eagle/eagle.h"
#define SEIRITU   1
#define HUSEIRITU 0
#define LMAX 10000

double ramuda;

void set_matrix(n, delta_x, AA, BB, CC)
int n;
double delta_x, AA[], BB[], CC[];
{
   int j;

   AA[0] = 1.0+2.0*ramuda; BB[0] = -2.0*ramuda; CC[0] = 0.0;
   for (j = 1; j < n; j++) {
      AA[j] = 1.0 + 2.0*ramuda;
      BB[j] = -ramuda;
      CC[j] = -ramuda;
   }
   AA[n] = 1.0 + 2.0*ramuda; BB[n] = 0.0; CC[n] = -2.0*ramuda;
}

main()
{
   Window w0;
   double d, L, delta_x, delta_t, s, umax, umin, x, pai, max, min;
   double u[LMAX], uu[LMAX], AA[LMAX], BB[LMAX], CC[LMAX];
   int i, n, t, jikan, wx, wy, genri, satisfied;
   unsigned long black, blue;

   wx = 840; wy = 400;
   satisfied = 0;

   w0 = x_init(wx, wy+50, "kadai24");
   black = set_color(  0,   0,   0);
   blue  = set_color(  0,   0, 255);

   printf("d = ");
   scanf("%lf", &d);

   printf("L = ");
   scanf("%lf", &L);

   printf("n = ");
   scanf("%d", &n);

   delta_x = L/(double)n;

   printf("ramuda = ");
   scanf("%lf", &ramuda);

   delta_t = ramuda*delta_x*delta_x/d;

   pai = 3.14159265;

   set_matrix(n, delta_x, AA, BB, CC);
   LUdecomp(n+1, AA, BB, CC);

   genri = SEIRITU;

   umax = 1.0e-50;
   umin = -umax;

   max = 1.0e-50;
   min = -max;

   srand48(time(0));
   for(i = 0; i <= n; i++) {
      s = drand48();
      if (s < 0.25)
         s = s/1000.0;
      else if ((0.25 <= s) && (s < 0.5))
         s = -s/1000.0;
      else if ((0.5 <= s) && (s < 0.75))
         s = s/1000.0;
      else
         s = -s/1000.0;

      x = i*delta_x;

      /*u[i] = cos(pai*x/L) + 3.0*cos(2.0*pai*x/L) + cos(3.0*pai*x/L) + s ;*/
      u[i] = cos(pai*x/L);

      if (umax < u[i])
         umax = u[i];
      if (umin > u[i])
         umin = u[i];
   }
   
   while (satisfied != 1) {
      LUsolve(n+1, AA, BB, CC, u);

      for(i = 0; i < n; i++) {
         if (max < u[i])
            max = u[i];
         if (min > u[i])
            min = u[i];

         if (umax < max)
            genri = HUSEIRITU;
         if (umin > min)
            genri = HUSEIRITU;        
      }
      w_clear();
      m_trans_def(0.0, -5.0, L, 5.0, 20, 60, wx-40, wy-60);
      set_foreground(black);
      m_box(0.0, -5.0, L, 5.0, 0);
      m_line(0.0, 0.0, L, 0.0);
      set_foreground(blue);

      m_graph(n, 0.0, L, u);
   } 
   w_close(w0);
   x_term();
}   
