/* kadai26.c */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../csc/csc.h"
#include "../eagle/eagle.h"
#define LMAX 21

main()
{
   Window w0;
   double d, LX, LY, ramuda, delta_x, delta_t, delta_y, s, x, y, pai;
   double u[LMAX][LMAX], uu[LMAX][LMAX];
   int i, j, t, jikan, wx, wy, satisfied, count;
   int nx, ny;
   unsigned long black, blue;

   wx = 600; wy = 600;
   satisfied = 0;

   w0 = x_init(wx, wy, "kadai26");
   black = set_color(  0,   0,   0);
   blue  = set_color(  0,   0, 255);

   printf("d = ");
   scanf("%lf", &d);

   printf("LX = ");
   scanf("%lf", &LX);

   printf("LY = ");
   scanf("%lf", &LY);

   printf("nx = ");
   scanf("%d", &nx);

   printf("ny = ");
   scanf("%d", &ny);

   delta_x = LX/(double)nx;
   delta_y = LY/(double)ny;

   printf("delta_t = ");
   scanf("%lf", &delta_t);

   pai = 3.14159265;

   for(i = 0; i <= nx; i++) {
      for(j = 0; j <= ny; j++) {
         u[i][j] = 0.0;
      }
   }

   srand48(time(0));
   for(i = 0; i <= nx; i++) {
      x = i*delta_x;
      for(j = 0; j <= ny; j++) {
         s = drand48();
         if (s < 0.25)
            s = s/1000.0;
         else if ((0.25 <= s) && (s < 0.5))
            s = -s/1000.0;
         else if ((0.5 <= s) && (s < 0.75))
            s = s/1000.0;
         else
            s = -s/1000.0;

         y = j*delta_y;

         u[i][j] = cos(pai*x/LX)*cos(pai*y/LY) + 2.0*cos(4.0*pai*x/LX)*cos(3.0*pai*y/LY) + s;
      }
   }
   
   set_foreground(blue);
   m_hidden(-3.1, 3.1, 0.7, 0.3, 50, 50, 350, 150, u, nx+1, ny+1,
             1, 1, 1, 1, 1);

   count = 0;

   while (satisfied != 1) {
      for(i=0; i <= nx; i++){
         for(j = 0; j <= ny; j++) {
            if ((i == 0) && (j == 0)) {
               uu[i][j] = u[i][j] + delta_t*d*((2.0*u[i+1][j] - 2.0*u[i][j])/delta_x/delta_x
                                         + (2.0*u[i][j+1] -2.0*u[i][j])/delta_y/delta_y);
            }
            else if ((i == 0) && (j == ny)) {
               uu[i][j] = u[i][j] + delta_t*d*((2.0*u[i+1][j] - 2.0*u[i][j])/delta_x/delta_x
                                         + (-2.0*u[i][j] + 2.0*u[i][j-1])/delta_y/delta_y);
            }
            else if ((i == nx) && (j == 0)) {
               uu[i][j] = u[i][j] + delta_t*d*((-2.0*u[i][j] + 2.0*u[i-1][j])/delta_x/delta_x
                                         + (-2.0*u[i][j] + 2.0*u[i][j+1])/delta_y/delta_y);
            }
            else if ((i == nx) && (j == ny)) {
               uu[i][j] = u[i][j] + delta_t*d*((- 2.0*u[i][j] + 2.0*u[i-1][j])/delta_x/delta_x
                                         + (-2.0*u[i][j] + 2.0*u[i][j-1])/delta_y/delta_y);
            }
            else if ((i == 0) && (j != 0) && (j != ny)) {
               uu[i][j] = u[i][j] + delta_t*d*((2.0*u[i+1][j] - 2.0*u[i][j])/delta_x/delta_x
                                         + (u[i][j+1] -2.0*u[i][j] + u[i][j-1])/delta_y/delta_y);
            }
            else if ((i == nx) && (j != 0) && (j != ny)) {
               uu[i][j] = u[i][j] + delta_t*d*((- 2.0*u[i][j] + 2.0*u[i-1][j])/delta_x/delta_x
                                         + (u[i][j+1] -2.0*u[i][j] + u[i][j-1])/delta_y/delta_y);
            }
            else if ((i != 0) && (i != nx) && (j == 0)) {
               uu[i][j] = u[i][j] + delta_t*d*((u[i+1][j] - 2.0*u[i][j] + u[i-1][j])/delta_x/delta_x
                                         + (2.0*u[i][j+1] -2.0*u[i][j])/delta_y/delta_y);
            }
            else if ((i != 0) && (i != nx) && (j == ny)) {
               uu[i][j] = u[i][j] + delta_t*d*((u[i+1][j] - 2.0*u[i][j] + u[i-1][j])/delta_x/delta_x
                                         + (-2.0*u[i][j] + 2.0*u[i][j-1])/delta_y/delta_y);
            }
            else {
               uu[i][j] = u[i][j] + delta_t*d*((u[i+1][j] - 2.0*u[i][j] + u[i-1][j])/delta_x/delta_x 
                                            + (u[i][j+1] -2.0*u[i][j] + u[i][j-1])/delta_y/delta_y);
            }
         }
      }

      count = count++;

      for (i = 0; i <= nx; i++) {
         for (j = 0; j <= ny; j++) {
            u[i][j] = uu[i][j];
         }
      }

      if (count == 10) {
         w_clear();
         set_foreground(blue);

         m_hidden(-3.1, 3.1, 0.7, 0.3, 50, 50, 350, 150, u, nx+1, ny+1, 
                   1, 1, 1, 1, 1);

         count = 0;
      }
   }
   w_close(w0);
   x_term();
}   
