#include <stdio.h>
#include <glsc.h>
#include <math.h>

#define GRAPH_NAME	"nc13"

#define SIGN		"nc13 / t930028 / Nobuyuki Okada"
#define SIGN_LEFT_MM	5.0
#define SIGN_TOP_MM	20.0

#define WINDOW_X_SIZE   140.0
#define WINDOW_Y_SIZE   100.0

#define X_LEFT_MM       20.0
#define Y_TOP_MM        30.0
#define X_SIZE_MM       100.0
#define Y_SIZE_MM       50.0

#define X_MIN           -50.0
#define X_MAX           50.0
#define Y_MIN           -50.0
#define Y_MAX           50.0

#define DELTA_T		0.1

#define A               10.0
#define OMEGA		0.5
#define BALL_RADIUS	20.0

#define V_FACTOR	4.0
#define A_FACTOR	4.0

extern void g_vector();

main(){
  int i;
  double x, y, v_x, v_y, a_x, a_y, time;

  g_init( GRAPH_NAME, WINDOW_X_SIZE, WINDOW_Y_SIZE );
  g_device( G_DISP );
  g_def_scale( 0, X_MIN, X_MAX, Y_MIN, Y_MAX,
	      X_LEFT_MM, Y_TOP_MM, X_SIZE_MM, Y_SIZE_MM );
  g_sel_scale( 0 );
  g_cls();

  g_text( SIGN_LEFT_MM, SIGN_TOP_MM, SIGN );

  g_marker_type( G_MARKER_F_CIRC );
  g_marker_size( 1 );

  for( i = 0; ; i++ ){
    time = i*DELTA_T;

    x = A*cos(OMEGA*time);
    y = 0.0;

    v_x = -A*OMEGA*sin(OMEGA*time);
    v_y = 0.0;

    a_x = -A*OMEGA*cos(OMEGA*time);
    a_y = 0.0;

    g_line_color( G_CYAN );
    g_area_color( G_CYAN );
    g_circle( x, y, BALL_RADIUS, G_YES, G_YES );
    g_line_color( G_BLUE );
    g_area_color( G_BLUE );
    g_vector( x, y+5.0, v_x, v_y, V_FACTOR );
    g_line_color( G_RED );
    g_area_color( G_RED );
    g_vector( x, y, a_x, a_y, A_FACTOR );

    g_line_color( G_WHITE );
    g_area_color( G_WHITE );
    g_sleep( 0.05 );
    g_circle( x, y,  BALL_RADIUS, G_YES, G_YES );
    g_vector( x, y+5.0, v_x, v_y, V_FACTOR );
    g_vector( x, y, a_x, a_y, A_FACTOR );
  }

}

/* plot vector */
void g_vector( x_org, y_org, x_comp, y_comp, factor )
double x_org, y_org, x_comp, y_comp, factor;
{
  g_marker( x_org, y_org );
  g_move( x_org, y_org );
  g_plot( x_org+x_comp*factor, y_org+y_comp*factor );
}
