#include <stdio.h>
#include <glsc.h>
#include <math.h>

#define GRAPH_NAME	"nc13_2"

#define SIGN		"nc13_2 / t930028 / Nobuyuki Okada"
#define SIGN_LEFT_MM	5.0
#define SIGN_TOP_MM	20.0

#define WINDOW_X_SIZE   140.0
#define WINDOW_Y_SIZE   140.0

#define X_LEFT_MM       20.0
#define Y_TOP_MM        30.0
#define X_SIZE_MM       100.0
#define Y_SIZE_MM       50.0

#define X_MIN           0.0
#define X_MAX           0.45
#define Y_MIN           0.0
#define Y_MAX           0.25

#define DELTA_T		0.02

#define U               1.0
#define V               2.0
#define G               9.8
#define BALL_RADIUS	0.05

#define V_FACTOR	0.03
#define A_FACTOR	0.01

extern void g_vector();

main(){
  int i;
  double x, y, v_x, v_y, a_x, a_y, time;

  g_init( GRAPH_NAME, WINDOW_X_SIZE, WINDOW_Y_SIZE );
  g_device( G_DISP );
  g_def_scale( 0, X_MIN, X_MAX, Y_MIN, Y_MAX,
	      X_LEFT_MM, Y_TOP_MM, X_SIZE_MM, Y_SIZE_MM );
  g_sel_scale( 0 );
  g_cls();

  g_text( SIGN_LEFT_MM, SIGN_TOP_MM, SIGN );

  g_marker_type( G_MARKER_STAR );
  g_marker_size( 1 );

  for( i = 0; i < 20; i++ ){
    time = i*DELTA_T;

    x = U*time;
    y = V*time - G/2*time*time;

    v_x = U;
    v_y = V - G*time;

    a_x = 0.0;
    a_y = -G;

    g_line_color( G_CYAN );
    g_area_color( G_CYAN );
    g_circle( x, y, BALL_RADIUS, G_YES, G_YES );
    g_line_color( G_BLUE );
    g_area_color( G_BLUE );
    g_vector( x, y, v_x, v_y, V_FACTOR );
    g_line_color( G_RED );
    g_area_color( G_RED );
    g_vector( x, y, a_x, a_y, A_FACTOR );

    g_line_color( G_WHITE );
    g_area_color( G_WHITE );
    g_sleep( 0.1 );
    g_circle( x, y,  BALL_RADIUS, G_YES, G_YES );
    g_vector( x, y+1.0, v_x, v_y, V_FACTOR );
    g_vector( x, y, a_x, a_y, A_FACTOR );
  }

}

/* plot vector */
void g_vector( x_org, y_org, x_comp, y_comp, factor )
double x_org, y_org, x_comp, y_comp, factor;
{
  g_marker( x_org, y_org );
  g_move( x_org, y_org );
  g_plot( x_org+x_comp*factor, y_org+y_comp*factor );
}
