#include <stdio.h>
#include <math.h>
#include <glsc.h>

#define GRAPH_NAME "graph14"
 
#define WINDOW_X_SIZE 150.0
#define WINDOW_Y_SIZE 150.0

#define SIGN "nc14 / t930028 / Nobuyuki Okada"
#define SIGN_LEFT_MM 5.0
#define SIGN_TOP_MM  10.0

#define X_LEFT_MM 10.0
#define Y_TOP_MM  20.0
#define X_SIZE_MM 120.0
#define Y_SIZE_MM 120.0

#define X_MAX 10.0
#define X_MIN 0.0
#define Y_MAX 10.0
#define Y_MIN 0.0

#define MAX 1001

extern double y();
extern double func();
extern double Euler();

main()
{
   int i;
   double del_x, x, y[MAX];
   
   g_init(GRAPH_NAME, WINDOW_X_SIZE, WINDOW_Y_SIZE);
   g_device(G_DISP);
   g_def_scale(0, X_MIN, X_MAX, Y_MIN, Y_MAX, X_LEFT_MM, Y_TOP_MM,
                 X_SIZE_MM, Y_SIZE_MM);
   g_sel_scale(0);
   g_cls();

   g_text(SIGN_LEFT_MM, SIGN_TOP_MM, SIGN);

   del_x = (X_MAX - X_MIN) / 10.0;

   y[0] = 1.0;

   for (i = 1; i <= 10; i++) {
      x = X_MIN + del_x*(i-1);
      y[i] = Euler(x, 1.0, y[i-1]);
   }
   g_line_color(G_GREEN);
   g_data_plot(X_MIN, X_MAX, y, 11);

   del_x = (X_MAX - X_MIN) / 100.0;

   y[0] = 1.0;

   for (i = 1; i <= 100; i++) {
      x = X_MIN + del_x*(i-1);
      y[i] = Euler(x, 0.1, y[i-1]);
   }
   g_line_color(G_BLUE);
   g_data_plot(X_MIN, X_MAX, y, 101);

   del_x = (X_MAX - X_MIN) / 1000.0;

   y[0] = 1.0;

   for (i = 1; i <= 1000; i++) {
      x = X_MIN + del_x*(i-1);
      y[i] = Euler(x, 0.01, y[i-1]);
   }
   g_line_color(G_RED);
   g_data_plot(X_MIN, X_MAX, y, 1001);

   del_x = (X_MAX - X_MIN) / 1000.0;

   for (i = 0; i <= 1000; i++) {
      x = X_MIN + del_x*i;
      y[i] = exp(1 - cos(x));
   }
   g_line_color(G_CYAN);
   g_data_plot(X_MIN, X_MAX, y, 1001);

   g_line_color(G_BLACK);
   g_move(X_MIN, Y_MIN);
   g_plot(X_MAX, Y_MIN);

   g_move(X_MIN, Y_MIN);
   g_plot(X_MIN, Y_MAX);

   g_sleep(-1.0);
   g_term();
}

double y(time)
double time;
{
   return exp(1 - cos(time));
}

double func(time, atai)
double time, atai;
{
   return atai*sin(time);
}

double Euler(time, delta_t, atai)
double time, delta_t, atai;
{
   return atai + delta_t*func(time, atai);
}



