#include <stdio.h>
#include <math.h>

extern void trapezoid();
extern double func();

void trapezoid(a, b, epsilon, kaisuu_limit)
double a, b, epsilon;
int kaisuu_limit;
{
   double h, T_N, T_2N, s, I;
   int i, N, kaisuu;

   T_N = (b-a)*(func(a) + func(b)) / 2.0;
   N = 1;

   for (kaisuu = 0; kaisuu < kaisuu_limit; kaisuu++) {
      N = 2*N;
      h = (b-a) / N;
      s = 0.0;

      for (i = 1; i < N; i = i+2) {
         s = s + func(a+i*h);
      }

      T_2N = T_N/2.0 + h*s;

      if (fabs(T_2N - T_N) < epsilon*fabs(T_2N)) exit(1);
 
      T_N = T_2N;

      I = (2.0*sqrt(2.0)-1.0) / 3.0;

      if (N == 8 || N == 16 || N == 32 || N == 64) {
         printf("N = %2d  kai = %le  gosa = %le\n", N, T_N, fabs(T_N-I)); 
      }
   }

   printf("Error : kaisuu_limit!\n");
   exit(0);
}

double func(x)
double x;
{
   return x*sqrt(1.0 + x*x);
}

main()
{
   double a, b, epsilon;
   int kaisuu_limit, i;

   printf("a = ");
   scanf("%le", &a);  

   printf("b = ");
   scanf("%le", &b);

   printf("epsilon = ");
   scanf("%le", &epsilon);

   printf("kaisuu_limit = ");
   scanf("%d", &kaisuu_limit);

   trapezoid(a, b, epsilon, kaisuu_limit);
}

