#include <stdio.h>
#include <math.h>

extern double trapezoid();
extern double func();

int count = 0;

double trapezoid(a, b, epsilon, kaisuu_limit)
double a, b, epsilon;
int kaisuu_limit;
{
   double h, T_N, T_2N, s;
   int i, N, kaisuu;

   T_N = (b-a)*(func(a) + func(b)) / 2.0;
   N = 1;

   for (kaisuu = 0; kaisuu < kaisuu_limit; kaisuu++) {
      N = 2*N;
      h = (b-a)/N;
      s = 0.0;

      for (i = 1; i < N; i = i+2) {
         s = s + func(a+i*h);
      }

      T_2N = T_N/2.0 + h*s;

      if (fabs(T_2N - T_N) < epsilon*fabs(T_2N)) {
         return T_2N;
      }

      T_N = T_2N;
   }

   printf("Error : kaisuu_limit!\n");
   exit(0);
}

double func(x)
double x;
{
   count++;

   return 1.0 / sqrt((1.0 + 4.0*x*x)*(1.0 + 3.0*x*x));
}

main()
{
   double a, b, epsilon;
   int kaisuu_limit;

   printf("a = ");
   scanf("%le", &a);

   printf("b = ");
   scanf("%le", &b);

   printf("epsilon = ");
   scanf("%le", &epsilon);

   printf("kaisuu_limit = ");
   scanf("%d", &kaisuu_limit);

   printf("%le \n", trapezoid(a, b, epsilon, kaisuu_limit));
   printf("׻: %d\n", count);
}
