#include <stdio.h>
#include <math.h>

extern void simpson();
extern double func();

void simpson(a, b, epsilon, kaisuu_limit)
double a, b, epsilon;
int kaisuu_limit;
{
   double h, T_N, T_2N, S_N, S_2N, s, I;
   int i, N, kaisuu;

   T_N = (b-a) / 2.0 * (func(a)/2.0 + func((a+b)/2.0) + func(b)/2.0);
   S_N = (b-a) / 2.0 * (func(a) + 4.0 * func((a+b)/2.0) + func(b)) / 3.0;
   N = 2;

   for (kaisuu = 0; kaisuu < kaisuu_limit; kaisuu++) {
      N = 2*N;
      h = (b-a)/N;
      s = 0.0;

      for (i = 1; i < N; i = i+2) {
         s = s + func(a+i*h);
      }

      T_2N = T_N/2.0 + h*s;
      S_2N = (4.0*T_2N - T_N)/3.0;

      if (fabs(S_2N - S_N) < epsilon*fabs(S_2N)) {
         exit(0);
      }

      if (N == 8 || N == 16 || N == 32 || N == 64) { 
         I = (2.0*sqrt(2.0)-1.0) / 3.0;
         printf("N = %2d  S%2d = %le  gosa = %le\n", N, N, S_2N, fabs(I-S_2N));
      }

      T_N = T_2N;
      S_N = S_2N;
   }

   printf("Error : kaisuu_limit!\n");
   exit(0);
}

double func(x)
double x;
{
   return x*sqrt(1.0 + x*x);
}

main()
{
   double a, b, epsilon;
   int kaisuu_limit;

   printf("a = ");
   scanf("%le", &a);

   printf("b = ");
   scanf("%le", &b);

   printf("epsilon = ");
   scanf("%le", & epsilon);

   printf("kaisuu_limit = ");
   scanf("%d", &kaisuu_limit);

   simpson(a, b, epsilon, kaisuu_limit);
}
