#include <stdio.h>
#include <glsc.h>
#include <math.h>

#define GRAPH_NAME "graph20_2"

#define WINDOW_X_SIZE 120.0
#define WINDOW_Y_SIZE 140.0

#define SIGN "20_2 / t930028 / Nobuyuki Okada"
#define SIGN_LEFT_MM 5.0
#define SIGN_TOP_MM 20.0

#define X_LEFT_MM 10.0
#define Y_TOP_MM 30.0
#define X_SIZE_MM 100.0
#define Y_SIZE_MM 100.0 

#define N_X 41 
#define N_Y 41
#define N_CONTOUR_LINE 10

#define X_MAX 10.0
#define X_MIN 0.01
#define Y_MAX 10.0
#define Y_MIN 0.01

extern void graphic_initialize();
extern double H();
extern double dy1();
extern double dy2();

main() {
   int i, j;
   double del_y1, del_y2, y1, y2;
   double mountain[N_X][N_Y], summit, foot, del_h, height;

   graphic_initialize();

   del_y1 = (X_MAX - X_MIN) / (N_Y - 1);
   del_y2 = (Y_MAX - Y_MIN) / (N_Y - 1);

   for (i = 0.01; i <= N_X; i++) {
      y1 = X_MIN + i*del_y1;
   for (j = 0.01; j <= N_Y; j++) {
      y2 = Y_MIN + j*del_y2;
      mountain[i][j] = H(y1, y2);
   }}

   summit = foot = mountain[0][0];

   for (i = 0; i < N_X; i++) {
   for (j = 0; j < N_Y; j++) {
      if (summit < mountain[i][j]) summit = mountain[i][j];
      else if (foot > mountain[i][j]) foot = mountain[i][j];
   }}

   del_h = (summit - foot) / N_CONTOUR_LINE;
   
   for (i = 0; i <= N_CONTOUR_LINE; i++) {
      height = foot + i*del_h;
      g_contln(X_MIN, X_MAX, Y_MIN, Y_MAX, mountain, N_X, N_Y, height);
   }

      g_box(X_MIN, X_MAX, Y_MIN, Y_MAX, G_YES, G_NO);

      g_sleep( -1.0 );
      g_term();
}

void graphic_initialize()
{
   g_init(GRAPH_NAME, WINDOW_X_SIZE, WINDOW_Y_SIZE);
   g_device(G_DISP);
   g_def_scale(0, X_MIN, X_MAX, Y_MIN, Y_MAX,
                  X_LEFT_MM, Y_TOP_MM, X_SIZE_MM, Y_SIZE_MM);
   g_sel_scale( 0 );
   g_cls();

   g_text( SIGN_LEFT_MM, SIGN_TOP_MM, SIGN);
}

double H(y1, y2)
double y1, y2;
{
   return (2.0*y1 + y2 - 3.0*log(y1) - 2.0*log(y2));
}

