#include <stdio.h>
#define MAX 100

extern void LU_tri_decomp();
extern void LU_tri_subst();

void LU_tri_decomp(N, a, b, c, l, d)
int N;
double *a, *b, *c, *l, *d;
{
   int i;

   d[1] = a[1];

   for (i = 2; i <= N; i++) {
      l[i] = b[i]/d[i-1];
      d[i] = a[i] - l[i]*c[i-1];
   }
}

void LU_tri_subst(N, c, l, d, y, x)
int N;
double *c, *l, *d, *y, *x;
{
   int i;
   double z[MAX];

   z[1] = y[1];

   for (i = 2; i <= N; i++) {
      z[i] = y[i] - l[i]*z[i-1];
   }

   x[N] = z[N]/d[N];

   for (i = N-1; i >= 1; i--) {
      x[i] = (z[i] - c[i]*x[i+1]) / d[i];
   }
}

main()
{
   int N, i;
   double a[MAX], b[MAX], c[MAX], l[MAX], d[MAX], y[MAX], x[MAX];

   printf("N = ");
   scanf("%d", &N);

   for (i = 1; i <= N; i++) {
      printf("a%d = ", i);
      scanf("%le", &a[i]);
   }

   for (i = 1; i <= N; i++) {
      printf("b%d = ", i);
      scanf("%le", &b[i]);
   }

   for (i = 1; i <= N; i++) {
      printf("c%d = ", i);
      scanf("%le", &c[i]);
   }

   for (i = 1; i <= N; i++) {
      printf("y%d = ", i);
      scanf("%le", &y[i]);
   }

   LU_tri_decomp(N, a, b, c, l, d);

   for (i = 2; i <= N; i++) {
      printf("l(%2d) = %le\n", i, l[i]);
   }

   for (i = 1; i <= N; i++) {
      printf("d(%2d) = %le\n", i, d[i]);
   }

   LU_tri_subst(N, c, l, d, y, x);

   for (i = 1; i <= N; i++) {
      printf("x(%2d) = %le\n", i, x[i]);
   }
}
