#include <stdio.h>
#include <math.h>
#include <glsc.h>

#define N 500

#define WINDOW_X_SIZE 170.0
#define WINDOW_Y_SIZE 90.0

#define X_MIN         (-2.0)
#define X_MAX           2.0 
#define Y_MIN         (-1.0)
#define Y_MAX           1.0

#define X_LEFT_MM     10.0
#define Y_TOP_MM      30.0
#define X_SIZE_MM     100.0
#define Y_SIZE_MM     50.0

main() {
   int i;
   double del_x, x, y[N];

   g_init("graph6", WINDOW_X_SIZE, WINDOW_Y_SIZE);
   g_device( G_DISP );
   g_def_scale( 0, X_MIN, X_MAX, Y_MIN, Y_MAX, X_LEFT_MM, Y_TOP_MM,
                X_SIZE_MM, Y_SIZE_MM );
   g_sel_scale( 0 );
   g_cls();

   del_x = ( X_MAX - X_MIN ) / ( N - 1 );

   for( i = 0; i < N; i++ ) {
      x = X_MIN+del_x*i;
      y[i] = sin(exp(x));
   }

   g_data_plot( X_MIN, X_MAX, y, N );

   g_box(X_MIN, X_MAX, Y_MIN, Y_MAX, G_YES, G_NO);

   g_text(5.0,20.0, "graph1 / t930028 / Nobuyuki Okada");

   g_sleep( -1.0 );
   g_term();
}
                
