#include <stdio.h>
#include <glsc.h>

#define N 10

#define WINDOW_X_SIZE 130.0
#define WINDOW_Y_SIZE 150.0

#define X_MIN 0.0
#define X_MAX 1.0
#define Y_MIN 0.0
#define Y_MAX 1.0

#define X_LEFT_MM 10.0
#define Y_TOP_MM  30.0
#define X_SIZE_MM 100.0
#define Y_SIZE_MM 100.0

extern void g_vector();

main() {
   int i, j;
   double del_x, del_y, x, y;

   g_init("graph2", WINDOW_X_SIZE, WINDOW_Y_SIZE);
   g_device(G_DISP);
   g_def_scale(0, X_MIN, X_MAX, Y_MIN, Y_MAX, X_LEFT_MM, Y_TOP_MM,
               X_SIZE_MM, Y_SIZE_MM);
   g_sel_scale( 0 );
   g_cls();

   g_marker_size( 1 );
   g_marker_type( G_MARKER_F_CIRC );

   del_x = ( X_MAX - X_MIN ) / ( N - 1 );
   del_y = ( Y_MAX - Y_MIN ) / ( N - 1 );

   for (i = 0; i < N; i++) {
      x = del_x*i;
      
      for (j = 0; j < N; j++) {
         y = del_y*j;
         g_vector(x, y, -y, x, 0.05);
      }
   }

   g_move( X_MIN, Y_MIN );
   g_plot( X_MAX, Y_MIN );

   g_move( X_MIN, Y_MIN );
   g_plot( X_MIN, Y_MAX );

   g_text(5.0,20.0, "graph7 / t930028 / Nobuyuki Okada");
   g_sleep(-1.0);
   g_term();
}

void g_vector( x_org, y_org, x_comp, y_comp, factor)
double x_org, y_org, x_comp, y_comp, factor;
{
   g_move(x_org, y_org);
   g_marker(x_org, y_org);
   g_plot(x_org+x_comp*factor, y_org+y_comp*factor);
}
   
   
   


