/* newsmp13.c */
#include "../eagle/eagle.h"
#define Mmax (201)

int colornumber(x)
    double x;
{
    int cnn, j;
    cnn = 0;
    for (j = 1; j < 16; j++) if (x > -1.0 + 2.0/16*j) cnn = j;
    return cnn;
}

main()
{
    Window      w0;
    double      u[Mmax][Mmax];
    double      dx, dy, xmin, xmax, ymin, ymax, x, pai;
    int         wx, wy, Mx, My, i, j, k, s,  N, cn, end, iterate;
    unsigned long blue[16];
    extern int colornumber();

    Mx = 101; My = 101; dx = 1.0/(Mx-1); dy = 1.0/(My-1);
    pai = 3.14159; end = 0;

    wx = 600; wy = 600;
    w0 = x_init(wx, wy, "Eagle_data");
    m_trans_def(0.0, 0.0, 1.0, 1.0, 10, 10, 580, 580);
    for (j = 0; j < 16; j++)
       blue[j] = set_color(0, 0, 255-10*(15-j));

    for (i = 0; i < Mx; i++)
    for (j = 0; j < My; j++) {
      N = 0; x = 2.0*pai*(2.0*i+j+3*N)/(Mx+My);
      u[i][j] = sin(x);
    }

    w_clear(); m_box(0.0, 0.0, 1.0, 1.0, 0);
    for (i = 0; i < Mx; i++)
    for (j = 0; j < My; j++) {
      cn = colornumber(u[i][j]); set_foreground(blue[cn]);
      xmin = (i-0.52)*dx; xmax = xmin+dx*1.04;
      ymin = (j-0.52)*dy; ymax = ymin+dy*1.04;
      if (i == 0) xmin = 0.0; if (i == Mx-1) xmax = i*dx;
      if (j == 0) ymin = 0.0; if (j == My-1) ymax = j*dy;
      m_box(xmin, ymin, xmax, ymax, 1);
    }

    while (end != 1) {
       printf("How many times do you want to calculate.   iterate = ");
       scanf("%d", &iterate);
       for (k = 0; k < iterate/5; k++) {
	  for (s = 0; s < 5; s++) {
	    N = N + 1;
            for (i = 0; i < Mx; i++)
            for (j = 0; j < My; j++) {
              x = 2.0*pai*(2.0*i+j+3.0*N)/(Mx+My);
              u[i][j] = sin(x);
            }
	  }
          w_clear(); m_box(0.0, 0.0, 1.0, 1.0, 0);
          for (i = 0; i < Mx; i++)
          for (j = 0; j < My; j++) {
            cn = colornumber(u[i][j]); set_foreground(blue[cn]);
            xmin = (i-0.52)*dx; xmax = xmin+dx*1.04;
            ymin = (j-0.52)*dy; ymax = ymin+dy*1.04;
            if (i == 0) xmin = 0.0; if (i == Mx-1) xmax = i*dx;
            if (j == 0) ymin = 0.0; if (j == My-1) ymax = j*dy;
            m_box(xmin, ymin, xmax, ymax, 1);
          }
       }
       if (iterate == 0) end = 1;
    }  

    printf("Input 0 to terminate  "); scanf("%d", &s);
    w_close(w0); x_term();
}

