#include <stdio.h>
#include <math.h>
#include <glsc.h>

#define WINDOW_X_SIZE   170.0
#define WINDOW_Y_SIZE   90.0

#define X_MIN           0.0
#define X_MAX           1.0
#define Y_MIN           (-1.0)
#define Y_MAX           1.0

#define X_LEFT_MM       10.0
#define Y_TOP_MM        30.0
#define X_SIZE_MM       150.0
#define Y_SIZE_MM       50.0

main(){
	int i;
	double y[51];

	g_init( "graph3", WINDOW_X_SIZE, WINDOW_Y_SIZE );
	g_device( G_DISP );
	g_def_scale( 0, X_MIN, X_MAX, Y_MIN, Y_MAX,
			X_LEFT_MM, Y_TOP_MM, X_SIZE_MM, Y_SIZE_MM );
	g_sel_scale( 0 );
	g_cls();

	for( i = 0; i <= 50; i++ ){
		y[i] = sin( -10.0 + 0.4*i );
	}

	g_data_plot( X_MIN, X_MAX, y, 51 );

	for( i = 0; i <= 50; i++ ){
		y[i] = cos( -10.0 + 0.4*i );
	}

	g_line_type( G_LINE_DASHED );
	g_data_plot( X_MIN, X_MAX, y, 51 );

	g_line_type( G_LINE_SOLID );
	g_box( X_MIN, X_MAX, Y_MIN, Y_MAX, G_YES, G_NO );
	
	g_text( 5.0, 20.0, "graph3 / t930000 / Daisuke Takahashi" );

	g_sleep( -1.0 );
	g_term();
}
