/*------------------------------*/
/*   sample4.c : graph of x*x   */
/*     by Daisuke Takahashi     */
/*------------------------------*/

#include <stdio.h>
#include <math.h>
#include <glsc.h>

#define GRAPH_NAME	"graph4"
#define WINDOW_X_SIZE   120.0
#define WINDOW_Y_SIZE   140.0

#define SIGN		"graph4 / t930000 / Daisuke Takahashi"
#define SIGN_LEFT_MM	5.0
#define SIGN_TOP_MM	20.0

#define X_MIN           0.0
#define X_MAX           1.0
#define Y_MIN           0.0
#define Y_MAX           1.0

#define X_LEFT_MM       10.0
#define Y_TOP_MM        30.0
#define X_SIZE_MM       100.0
#define Y_SIZE_MM       100.0

#define N		21

main(){
	int i;
	double del_x, x, y[N];

	g_init( GRAPH_NAME, WINDOW_X_SIZE, WINDOW_Y_SIZE );
	g_device( G_DISP );
	g_def_scale( 0, X_MIN, X_MAX, Y_MIN, Y_MAX,
			X_LEFT_MM, Y_TOP_MM, X_SIZE_MM, Y_SIZE_MM );
	g_sel_scale( 0 );
	g_cls();

	g_text( SIGN_LEFT_MM, SIGN_TOP_MM, SIGN );

	del_x = ( X_MAX - X_MIN ) / ( N - 1 );

	for( i = 0; i < N; i++ ){
		x = del_x*i;
		y[i] = x*x;
	}

	g_data_plot( X_MIN, X_MAX, y, N );

	g_marker_type( G_MARKER_F_CIRC );
	g_marker_size( 2 );

	for( i = 0; i < N; i++ ){
		x = del_x*i;
		g_marker( x, y[i] );
	}

	g_move( X_MIN, Y_MIN );
	g_plot( X_MAX, Y_MIN );

	g_move( X_MIN, Y_MIN );
	g_plot( X_MIN, Y_MAX );

	g_sleep( -1.0 );
	g_term();
}
