/* kadai32.c */
#include "../eagle/eagle.h"
#define M 803
unsigned long ryukoku_grey2;
unsigned long ryukoku_ohmiya, ryukoku_fukakusa, ryukoku_seta;
unsigned long black;

void display(u, v, N)
    X_real u[], v[]; int N;
{
    set_line_width(3); w_clear();
    set_foreground(ryukoku_fukakusa); m_graph(N, 0.0, 1.0, v);
    set_foreground(ryukoku_seta); m_graph(N, 0.0, 1.0, u);
    set_line_width(1); m_line(0.0, 0.0, 1.0, 0.0);
}

main()
{
    Window w0, w1;
    int N, disp_interval, num_disp, ndisp, nnum, i, count;
    int si, satisfied, j, goukei;
    X_real aa, epsilon, gamma, L, dx, dt, dd, uu, vv, umin, umax;
    X_real u[M], v[M], unext[M];
    double a, b, c, d, s, U[5000], V[5000];
    FILE   *fp;

    Window w;
    KeySym key;
    int xinit, yinit, botton;

    aa = 0.25; epsilon = 0.004; gamma = 6.0; L = 400.0;
    N = M-3; dx = L/N; dt = 0.1;
    disp_interval = 100; num_disp = 300;
    dd = dt/dx/dx;

    printf("s = ");
    scanf("%lf", &s);

    w0 = x_init(1000, 400, "Eagle_data"); w1 = w_open(w0, 10,  10, 980, 380);
    ryukoku_grey2    = set_color(180, 180, 180);
    ryukoku_ohmiya   = set_color(120,   0, 120);
    ryukoku_fukakusa = set_color( 20, 160,  20);
    ryukoku_seta     = set_color( 70,  70, 220);
    black            = set_color(  0,   0,   0);
    set_background(ryukoku_ohmiya); w_clear();
    w_select(w1); set_background(ryukoku_grey2); w_clear();
    umin = -0.2; umax = 1.0;
    m_trans_def(0.0, umin, 1.0, umax, 0, 0, 980, 380);

    fp = fopen("FHNdata_right", "r");
 
    for (i = 0; i <= N; i++) {
       u[i] = 0.0;
       v[i] = 0.0;
    }
    display(u, v, N); sleep(3);

    i = 0; 
    while(fscanf(fp, "%lf, %lf", &a, &b) != EOF) {
       U[i] = a;
       V[i] = b;
       i = i+1;
    }
    fclose(fp);

    count = 0;
    si     = 0;
    satisfied = 1;

    while(satisfied != 0) {
	for (ndisp=0; ndisp<disp_interval; ndisp++) {
           for (i=1; i<N; i++) {
                 uu = u[i]; vv = v[i];
                 unext[i] = uu + dd*(u[i+1]+u[i-1]-2.0*u[i])
                               + dt*(uu*(1.0-uu)*(uu-aa)-vv);
                 v[i] = vv + dt*epsilon*(uu-gamma*vv);
           }
           v[0] = v[0] + dt*epsilon*(u[0]-gamma*v[0]);
           uu = u[N]; vv = v[N];
           unext[N] = uu + dd*(2.0*u[N-1]-2.0*u[N])
                         + dt*(uu*(1.0-uu)*(uu-aa)-vv);
           v[N] = vv + dt*epsilon*(uu-gamma*vv);

	   for (i=1; i<=N; i++) u[i] = unext[i];

           if (count < 764) {
              u[0] = 1.0;
              v[0] = V[count];
              count = count+1;
              si = 0;
           }
           else if (si < s/dt) {
              u[0] = 0.0; v[0] = 0.0;
              si = si+1;

              if ( si > s/dt-1) {
                 count = 0;
              }
           }

           if(e_nowait(2,&xinit,&yinit,&botton,&w,&key) == True) {
              if(key == XK_u) {
                 s = s + 1;
              }
              else if(key == XK_d) {
                 s = s - 1;
                 if (s < 0) s = 0;
              }
              else if(key == XK_Escape) {
                 exit(1);
              }
           }
	}
        display(u, v, N);
        set_foreground(black);
        x_printf(10, 380, "s = %lf", s);
    }
    sleep(3);

    w_close(w1); w_close(w0);
    x_term();
}
